orchONA <- function(ID, GR, niter = 100, weight = 1000,...) {
totalmin <- 9999999999999
set.seed(5)

if (sum(ID[,2]) != max(GR))
  stop("Number of positions on the grid does not correspond to the number of trees.")

orchardgrid <- GR
orchardgrid[orchardgrid > 0] <- 0 #positions that should be filled
orchardgrid[GR == 0] <- -1 #positions that should remain empty

NCL <- max(ID[,1]) #total number of clones
NT <- max(GR) #total number of positions
rows <- nrow(orchardgrid)
columns <- ncol(orchardgrid)
empty <- length(which(orchardgrid == 0)) # Number of empty positions (0)

clonalsize <- 1:NCL
clonalsize <- ID[,2]
count <- 1
trees <- 1:NT
for (i in 1:NCL){
  ii <- clonalsize[i]
  for (j in 1:ii){
    trees[count] <- i
    count <- count + 1
    }
}
TR <- trees
ONA <- GR #matrix to store the final ONA layout

#==================ORCHARD===============================
eo <- 1 #to switch between systematic and random search algorithms
for (iter in 1:niter) {
  eo <- 1 - eo
  if(eo == 0){ #systematic
    cat("iter(s) = ", iter, "\n")
  } else { #random
    cat("iter(r) = ", iter, "\n")
  }
  #cat("orchard = ", orchardgrid)
  #if(iter == 2) stop()
  penalty <- 0
  trees <- TR
  orchard <- orchardgrid
#-------SHUFFLE POSITIONS FOR RANDOM ALLOCATION----------

  rand_rows <- sample.int(rows, rows)
  rand_cols <- sample.int(columns, columns)

#--------------------------------------------------------
  #snc = 0 #if spiral
  for (i_0 in 1:rows) {
    for (j_0 in 1:columns) {
#-----------------SYSTEMATIC/RANDOM ALLOCATION------------------
      if(eo == 0){ #systematic
        i <- i_0
        j <- j_0
      } else { #random
        i <- rand_rows[i_0]
        j <- rand_cols[j_0]
      }
#-----------------SPIRAL ALLOCATION (experimental)------------------
      #snc = snc + 1
      #sncx = c(5,6,6,5,4,4,4,5,6,7,7,7,7,6,5,4,3,3,3,3,3,4,5,6,7,8,8,8,7,6,5,4,3,2,2,2,2,2,4,5,6,7,8,9,9,9,9,9,8,7,6,5,4,3,2,1,1,1,1,1,5,6,7,8,9,6,7,8,9,1,1,1,1,1,2,2,2,2,3,3,3,4,4,5,8,8,8,9,9,9)
      #sncy = c(5,5,4,4,4,5,6,6,6,6,5,4,3,3,3,3,3,4,5,6,7,7,7,7,7,4,3,2,2,2,2,2,2,2,3,4,5,6,8,8,8,8,8,8,4,3,2,1,1,1,1,1,1,1,1,1,2,3,4,5,9,9,9,9,9,10,10,10,10,6,7,8,9,10,7,8,9,10,8,9,10,9,10,10,5,6,7,5,6,7)
      #i <- sncx[snc]
      #j <- sncy[snc]

#--------------------------------------------------------
      if(orchard[i,j] == 0) {
#-----------------EVALUATION-----------------------------
        NC <- (sum(trees > 0)) # number of trees not allocated
        # sample randomly trees that are not allocated and store them in a vector
        if(NC > 1) {
          candidates <- sample(trees[trees > 0], NC)
        } else {
          candidates <- max(trees)
        }
        # now evaluate each candidate (one at a time)
        min <- 99999999999
        for (k in seq_len(NC)) {
          orchard[i,j] <- candidates[k]
#>>>>>>>>>>>>>>>>>>NEIGHBOURS<<<<<<<<<<<<<<<<<<<<<<<<<<<
          # this will require some cleanup in the future package release
          # loop through the whole matrix and sum all pair-wise matches
          pairs <- array(0:0, dim = c(NCL,NCL))
          penalty <- 0

          for (r in 1:rows) {
            for (c in 1:columns) {
              left = 0; right = 0; up = 0; down = 0
              leftup = 0; rightup = 0; leftdown = 0; rightdown = 0

              center <- orchard[r,c]

              if(center != -1){

              if(c == 1) {
                left <- 0
                if(r == 1) {
                  right <- orchard[1,2]
                  rightdown <- orchard[2,2]
                  down <- orchard[2,1]
                }
                if(r > 1 && r < rows) {
                  up <- orchard[r-1,1]
                  rightup <- orchard[r-1,2]
                  right <- orchard[r,2]
                  rightdown <- orchard[r+1,2]
                  down <- orchard[r+1,1]
                }
                if(r == rows) {
                  up <- orchard[r-1,1]
                  right <- orchard[r,2]
                  rightup <- orchard[r-1,c+1]
                }
              }

              if(c > 1 && c < columns) {
                if(r == 1) {
                  left <- orchard[r,c-1]
                  right <- orchard[r,c+1]
                  leftdown <- orchard[r+1,c-1]
                  down <- orchard[r+1,c]
                  rightdown <- orchard[r+1,c+1]
                }
                if(r > 1 && r < rows) {
                  leftup <- orchard[r-1,c-1]
                  up <- orchard[r-1,c]
                  rightup <- orchard[r-1,c+1]
                  left <- orchard[r,c-1]
                  right <- orchard[r,c+1]
                  leftdown <- orchard[r+1,c-1]
                  down <- orchard[r+1,c]
                  rightdown <- orchard[r+1,c+1]
                }
                if(r == rows) {
                  leftup <- orchard[r-1,c-1]
                  up <- orchard[r-1,c]
                  rightup <- orchard[r-1,c+1]
                  left <- orchard[r,c-1]
                  right <- orchard[r,c+1]
                }
              }

              if(c == columns) {
                if(r == 1) {
                  left <- orchard[r,c-1]
                  down <- orchard[r+1,c]
                  leftdown <- orchard[r+1,c-1]
                }
                if(r > 1 && r < rows) {
                  up <- orchard[r-1,c]
                  down <- orchard[r+1,c]
                  leftup <- orchard[r-1,c-1]
                  left <- orchard[r,c-1]
                  leftdown <- orchard[r+1,c-1]
                }
                if(r == rows) {
                  up <- orchard[r-1,c]
                  left <- orchard[r,c-1]
                  leftup <- orchard[r-1,c-1]
                }
              }

              if(leftup > 0) {
                pairs[center,leftup] <- pairs[center,leftup] + 1
              }

              if(rightup > 0) {
                pairs[center,rightup] <- pairs[center,rightup] + 1
              }

              if(leftdown > 0) {
                pairs[center,leftdown] <- pairs[center,leftdown] + 1
              }

              if(rightdown > 0) {
                pairs[center,rightdown] <- pairs[center,rightdown] + 1
              }

              if(left > 0) {
                pairs[center,left] <- pairs[center,left] + 1
              }

              if(right > 0) {
                pairs[center,right] <- pairs[center,right] + 1
              }

              if(up > 0) {
                pairs[center,up] <- pairs[center,up] + 1
              }

              if(down > 0) {
                pairs[center,down] <- pairs[center,down] + 1
              }

                if(center == up) {
                  penalty <- penalty + 1
                }

                if(center == down) {
                  penalty <- penalty + 1
                }

                if(center == left) {
                  penalty <- penalty + 1
                }

                if(center == right) {
                  penalty <- penalty + 1
                }

                if(center == rightup) {
                  penalty <- penalty + 1
                }

                if(center == rightdown) {
                  penalty <- penalty + 1
                }

                if(center == leftdown) {
                  penalty <- penalty + 1
                }

                if(center == leftup) {
                  penalty <- penalty + 1
                0}
              }

            }
          }

          # remove reciprocals from the diagonal

          #diagonal <- diag(pairs)

          #for (z in 1:NT){
          #  if(diagonal[z] > 0) {
          #    diagonal[z] <- diagonal[z]/2
          #  }
          #}
          #diag(pairs) <- diagonal

          penalty <- penalty/2
          #size <- (NT*NT-NT)/2 # size of the upper triangular matrix
          # extract upper triangular values
          vec <- pairs[upper.tri(pairs)][order(-row(pairs)[upper.tri(row(pairs))])]

          #criterion <- var(upperTriangle(pairs, diag=FALSE))*((size-1)/size) + penalty*weight
          criterion <- var(vec) + penalty*weight
          cr_1 <- var(vec)
          cr_2 <- penalty
          #upperTriangle
          #upper.tri(x, diag = FALSE)
#>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            if(criterion < min) { # we store data on the best solution so far
            min <- criterion
            best.tree <- candidates[k]
          }
        }

        # and pick the best tree
        l <- 1
        best <- 0

        while(best == 0){
          if(isTRUE(trees[l] == best.tree)) {
            trees[l] <- 0
            orchard[i,j] <- best.tree
            best <- 1
          }
          l <- l + 1
        }
#--------------------------------------------------------
      }
    }
  }
  #cat("min", min, "\n")
  if(min < totalmin) {
    cat("--> variance:", round(cr_1, digits = 2), "\n")
    cat("--> penalty: ", round(cr_2, digits = 2), "\n")
    totalmin <- min
    ONA <- orchard
    PAIR <- pairs
#    cat("--> matrix ONA: ", "\n")
#    print(ONA)
#    cat("--> matrix PAIR: ", "\n")
#    print(PAIR)
    cat("-----------------", "\n")
    #cat("........................", "\n")
    #cat("Best variance:", var(upperTriangle(PAIR, diag=FALSE))*((size-1)/size), "\n")
    #cat("Best variance:", var(upperTriangle(PAIR, diag=FALSE)), "\n")
  }
}

#cat("orchard = ", orchard, "\n")
#cat(criterion)

  #cat("........................", "\n")
  #cat("totalmin", totalmin, "\n")
  #cat("totalmin", ONA, "\n")
  #cat("totalmin", PAIR, "\n")
  #cat("........................", "\n")
  #cat("Best variance:", var(upperTriangle(PAIR, diag=FALSE))*((size-1)/size), "\n")
  #cat("Best variance:", var(upperTriangle(PAIR, diag=FALSE)), "\n")

#========================================================
if(!is.null(rownames(ID))){
  for (i in 1:rows){
    for (j in 1:columns){
      if(ONA[i,j] >= 1){
        ONA[i,j] <- rownames(ID)[as.numeric(ONA[i,j])]
      }
    }
  }
}

ONA[ONA == -1] <- 0
ONA <- noquote(ONA)

diag(PAIR)<-diag(PAIR)/2 # remove reciprocals from the diagonal
PAIR <- upper.tri(PAIR, diag = TRUE)*PAIR
x = list("ONA" = ONA, "PAIR" = PAIR)
return(x)


#return(ONA)
}
